use editor_state::GraphEditorState;

mod graph_node_ui;

mod color_hex_utils;
mod editor_state;
mod graph_editor_egui;
mod graph_impls;
mod graph_types;
mod id_types;
mod index_impls;
mod node_finder;
mod node_types;
mod param_ui;

pub type SVec<T> = smallvec::SmallVec<[T; 4]>;

#[derive(Default)]
struct App {
    pub state: GraphEditorState,
}

impl epi::App for App {
    fn update(&mut self, ctx: &egui::CtxRef, frame: &epi::Frame) {
        egui::CentralPanel::default().show(ctx, |ui| {
            graph_editor_egui::draw_graph_editor(&ctx, &mut self.state);
        });
    }

    fn name(&self) -> &str {
        "Device Node Mapper"
    }
}

fn main() {
    let options = eframe::NativeOptions {
        ..Default::default()
    };

    eframe::run_native(Box::new(App::default()), options);
}
